Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraint.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraint.cs	(revision 17902)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraint.cs	(revision 17902)
@@ -0,0 +1,207 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+using System;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  [StorableType("8109BE58-CCFB-4462-A2F4-EEE5DFADAFF7")]
+  [Item("ShapeConstraint", "Constraint on the shape of a function e.g. monotonicity.")]
+  public sealed class ShapeConstraint : Item {
+    [Storable]
+    private string variable;
+
+    public string Variable {
+      get => variable;
+      private set {
+        if (variable == value)
+          return;
+        variable = value;
+        OnToStringChanged();
+        OnChanged();
+      }
+    }
+
+    public bool IsDerivative => NumberOfDerivations > 0;
+
+    [Storable]
+    private int numberOfDerivations;
+
+    public int NumberOfDerivations {
+      get => numberOfDerivations;
+      set {
+        if (value < 0 || value > 3)
+          throw new ArgumentException("Number of derivation has to be between 0 - 3.");
+        if (numberOfDerivations == value)
+          return;
+        numberOfDerivations = value;
+        OnToStringChanged();
+        OnChanged();
+      }
+    }
+
+    [Storable]
+    private Interval interval;
+
+    public Interval Interval {
+      get => interval;
+      set {
+        if (interval == value)
+          return;
+        interval = value;
+        OnToStringChanged();
+        OnChanged();
+      }
+    }
+
+    [Storable]
+    private IntervalCollection regions;
+    public IntervalCollection Regions {
+      get => regions;
+      set {
+        if (regions != value) {
+          if (regions != null) regions.Changed -= regions_Changed;
+          regions = value;
+          if (regions != null) regions.Changed += regions_Changed;
+          OnToStringChanged();
+          OnChanged();
+        }
+      }
+    }
+
+
+    [Storable]
+    private double weight = 1.0;
+    public double Weight {
+      get => weight;
+      set {
+        if (weight <= 0.0) throw new ArgumentOutOfRangeException("Weight must be larger than zero.");
+        if (weight != value) {
+          weight = value;
+          OnToStringChanged();
+          OnChanged();
+        }
+      }
+    }
+
+    [StorableConstructor]
+    private ShapeConstraint(StorableConstructorFlag _) : base(_) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      if (regions != null) regions.Changed += regions_Changed;
+    }
+
+    // without derivation
+    public ShapeConstraint(Interval interval, double weight)
+      : this(string.Empty, 0,
+         interval, new IntervalCollection(), weight) { }
+
+    public ShapeConstraint(Interval interval, IntervalCollection regions, double weight)
+      : this(string.Empty, 0,
+         interval, regions, weight) { }
+
+    public ShapeConstraint(string variable, int numberOfDerivations,
+                              Interval interval, double weight)
+      : this(variable, numberOfDerivations,
+             interval, new IntervalCollection(), weight) { }
+
+    public ShapeConstraint(string variable, int numberOfDerivations,
+                              Interval interval, IntervalCollection regions, double weight) {
+      Variable = variable;
+      NumberOfDerivations = numberOfDerivations;
+      Interval = interval;
+      Regions = regions;
+      Weight = weight;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ShapeConstraint(this, cloner);
+    }
+
+    private ShapeConstraint(ShapeConstraint original, Cloner cloner)
+      : base(original, cloner) {
+      Variable = original.Variable;
+      NumberOfDerivations = original.NumberOfDerivations;
+      Interval = original.Interval;
+      Regions = cloner.Clone(original.Regions);
+      Weight = original.weight;
+    }
+
+    public event EventHandler Changed;
+
+    private void OnChanged() {
+      var handlers = Changed;
+      if (handlers != null)
+        handlers(this, EventArgs.Empty);
+    }
+
+
+    private void regions_Changed(object sender, EventArgs e) {
+      OnToStringChanged();
+      OnChanged();
+    }
+
+    public override string ToString() {
+      return GenerateExpressionString();
+    }
+
+
+    private string GenerateExpressionString() {
+      string expression;
+
+      if (!IsDerivative) {
+        expression = string.Format($"f in [{Interval?.LowerBound} .. {Interval?.UpperBound}]");
+        if (Regions != null) {
+          foreach (var region in Regions.GetReadonlyDictionary())
+            expression += $", {region.Key} in [{region.Value.LowerBound} .. {region.Value.UpperBound}]";
+        }
+        if (Weight != 1.0) {
+          expression += $" weight: {weight}";
+        }
+
+        return expression;
+      }
+
+      var derivationString = string.Empty;
+      switch (numberOfDerivations) {
+        case 1:
+          derivationString = ""; break;
+        case 2:
+          derivationString = "²"; break;
+        case 3:
+          derivationString = "³"; break;
+      }
+      expression = string.Format($"∂{derivationString}f/∂{Variable}{derivationString} in [{Interval?.LowerBound} .. {Interval?.UpperBound}]");
+      if (Regions != null) {
+        foreach (var region in Regions.GetReadonlyDictionary())
+          expression += $", {region.Key} in [{region.Value.LowerBound} .. {region.Value.UpperBound}]";
+      }
+      if (Weight != 1.0) {
+        expression += $" weight: {weight}";
+      }
+      return expression;
+    }
+  }
+}
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraintsParser.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraintsParser.cs	(revision 17902)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraintsParser.cs	(revision 17902)
@@ -0,0 +1,242 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text.RegularExpressions;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  public static class ShapeConstraintsParser {
+    public static ShapeConstraints ParseConstraints(string text) {
+      if (string.IsNullOrEmpty(text)) throw new ArgumentNullException(nameof(text));
+
+      var lines = text.Split(new[] { "\r\n", "\r", "\n" }, StringSplitOptions.None);
+
+      var sc = new ShapeConstraints();
+      foreach (var line in lines) {
+        var trimmedLine = line.Trim();
+        if (trimmedLine == "") continue; // If it is a comment just continue without saving anything
+        if (trimmedLine.StartsWith("#")) {
+          // disabled constraints are commented
+          var constraint = ParseConstaint(trimmedLine.TrimStart('#', ' '));
+          sc.Add(constraint);
+          sc.SetItemCheckedState(constraint, false);
+        } else {
+          var constraint = ParseConstaint(trimmedLine);
+          sc.Add(constraint);
+          sc.SetItemCheckedState(constraint, true);
+        }
+      }
+      return sc;
+    }
+
+    public static ShapeConstraint ParseConstaint(string expr) {
+      var trimmedLine = expr.TrimStart();
+      if (trimmedLine.StartsWith("f")) {
+        return ParseFunctionRangeConstraint(expr);
+      } else if (trimmedLine.StartsWith("d") || trimmedLine.StartsWith("∂")) {
+        return ParseDerivationConstraint(expr);
+      } else {
+        throw new
+          ArgumentException("Error at your constraints definition constraints have to start with (f | d | ∂ | #)",
+                            nameof(expr));
+      }
+    }
+
+    // [124 .. 145]
+    private const string intervalRegex = @"\s*[\[]" +
+                                         @"\s*(?<lowerBound>[^\s\.;]*)" +
+                                         @"\s*(\.{2}|\s+|;)" +
+                                         @"\s*(?<upperBound>[^\s\]]*)" +
+                                         @"\s*[\]]";
+
+    private const string variableRegex = @"(['](?<varName>.*)[']|(?<varName>[^\s²³]+))\s*";
+    private const string weightRegex = @"\s*(weight:\s*(?<weight>\S*))?";
+    public static ShapeConstraint ParseFunctionRangeConstraint(string expr) {
+      if (!expr.StartsWith("f")) throw new ArgumentException("Invalid function range constraint (e.g. f in [1..2])", nameof(expr));
+      var start = "f".Length;
+      var end = expr.Length;
+      var targetConstraint = expr.Substring(start, end - start);
+
+
+      // # Example for a target variable constraint:
+      // f in [0 .. 100]
+      // # Example for constraints on model parameters: 
+      // df/d'x' in [0 .. 10]
+      // ∂²f/∂'x'² in [-1 .. inf.]
+      // df/d'x' in [0 .. 10] weight: 2.0
+      // df / d'x' in [0..10], 'x' in [1 .. 3]
+      // df / d'x' in [0..10], 'x' in [1 .. 3], y in [10..30] weight: 1.2
+
+      var match = Regex.Match(targetConstraint,
+                    @"\s*\bin\b" +
+                    intervalRegex +
+                    @"(" +
+                      @"\s*,\s*"+ variableRegex +
+                      @"\s *\bin\b" +
+                      intervalRegex +
+                    @")*" +
+                    weightRegex
+                    ); 
+
+
+      if (match.Success) {
+        // if (match.Groups.Count < 19) throw new ArgumentException("The target-constraint is not complete.", nameof(expr));
+
+        var lowerBound = ParseIntervalBounds(match.Groups["lowerBound"].Captures[0].Value);
+        var upperBound = ParseIntervalBounds(match.Groups["upperBound"].Captures[0].Value);
+        var interval = new Interval(lowerBound, upperBound);
+        var weight = 1.0;
+
+        if (match.Groups["weight"].Success && !string.IsNullOrWhiteSpace(match.Groups["weight"].Value))
+          weight = ParseAndValidateDouble(match.Groups["weight"].Value);
+
+        if (match.Groups["varName"].Success) {
+          IntervalCollection regions = new IntervalCollection();
+          // option variables found
+          for (int idx = 0; idx < match.Groups["varName"].Captures.Count; ++idx) {
+            KeyValuePair<string, Interval> region = ParseRegion(
+              variable: match.Groups["varName"].Captures[idx].Value,
+              lb: match.Groups["lowerBound"].Captures[idx + 1].Value,
+              ub: match.Groups["upperBound"].Captures[idx + 1].Value);
+            if (regions.GetReadonlyDictionary().All(r => r.Key != region.Key))
+              regions.AddInterval(region.Key, region.Value);
+            else
+              throw new ArgumentException("A constraint cannot contain multiple regions of the same variable.");
+          }
+          return new ShapeConstraint(interval, regions, weight);
+        } else
+          return new ShapeConstraint(interval, weight);
+      } else
+        throw new ArgumentException("The inserted target constraint is not valid.", nameof(expr));
+    }
+    public static ShapeConstraint ParseDerivationConstraint(string expr) {
+      var match = Regex.Match(expr,
+                                @"([d∂])" +
+                                @"(?<numDerivations>[²³]?)\s*" +
+                                @"f\s*" +
+                                @"(\/)\s*" +
+                                @"([d∂])\s*" +
+                                variableRegex +
+                                @"(?<numDerivations>[²³]?)\s*\bin\b\s*" +
+                                intervalRegex +
+                                @"(" +
+                                  @"\s*,\s*" + variableRegex +
+                                  @"\s *\bin\b" +
+                                  intervalRegex +
+                                  @")*" +
+                                weightRegex
+                                ); 
+
+      if (match.Success) {
+        // if (match.Groups.Count < 26)
+        //   throw new ArgumentException("The given derivation-constraint is not complete.", nameof(expr));
+
+        var derivationVariable = match.Groups["varName"].Captures[0].Value.Trim();
+
+        var enumeratorNumDeriv = match.Groups["numDerivations"].Captures[0].Value.Trim();
+        var denominatorNumDeriv = match.Groups["numDerivations"].Captures[1].Value.Trim();
+        if (enumeratorNumDeriv != "" || denominatorNumDeriv != "") {
+          if (enumeratorNumDeriv == "" || denominatorNumDeriv == "")
+            throw new ArgumentException("Number of derivation has to be written on both sides.", nameof(expr));
+          if (enumeratorNumDeriv != denominatorNumDeriv)
+            throw new ArgumentException("Derivation number is not equal on both sides.", nameof(expr));
+        }
+
+        var lowerBound = ParseIntervalBounds(match.Groups["lowerBound"].Captures[0].Value);
+        var upperBound = ParseIntervalBounds(match.Groups["upperBound"].Captures[0].Value);
+        var variable = derivationVariable;
+        var numberOfDerivation = ParseDerivationCount(enumeratorNumDeriv);
+        var interval = new Interval(lowerBound, upperBound);
+        var weight = 1.0;
+
+        if (match.Groups["weight"].Success && !string.IsNullOrWhiteSpace(match.Groups["weight"].Value))
+          weight = ParseAndValidateDouble(match.Groups["weight"].Value);
+
+        if (match.Groups["varName"].Captures.Count > 1) {
+          IntervalCollection regions = new IntervalCollection();
+          // option variables found
+          for (int idx = 0; idx < match.Groups["varName"].Captures.Count - 1; ++idx) {
+            KeyValuePair<string, Interval> region = ParseRegion(
+              variable: match.Groups["varName"].Captures[idx + 1].Value,
+              lb: match.Groups["lowerBound"].Captures[idx + 1].Value,
+              ub: match.Groups["upperBound"].Captures[idx + 1].Value);
+            if (regions.GetReadonlyDictionary().All(r => r.Key != region.Key))
+              regions.AddInterval(region.Key, region.Value);
+            else
+              throw new ArgumentException("A constraint cannot contain multiple regions of the same variable.");
+          }
+          return new ShapeConstraint(variable, numberOfDerivation, interval, regions, weight);
+        } else
+          return new ShapeConstraint(variable, numberOfDerivation, interval, weight);
+      } else
+        throw new ArgumentException("The inserted derivation constraint is not valid.", nameof(expr));
+    }
+
+
+    private static KeyValuePair<string, Interval> ParseRegion(string variable, string lb, string ub) {
+      var regionLb = ParseIntervalBounds(lb);
+      var regionUb = ParseIntervalBounds(ub);
+      return new KeyValuePair<string, Interval>(variable, new Interval(regionLb, regionUb));
+    }
+
+    private static double ParseIntervalBounds(string input) {
+      input = input.ToLower();
+      switch (input) {
+        case "+inf.":
+        case "inf.":
+          return double.PositiveInfinity;
+        case "-inf.":
+          return double.NegativeInfinity;
+        default: {
+            return ParseAndValidateDouble(input);
+          }
+      }
+    }
+
+    private static double ParseAndValidateDouble(string input) {
+      var valid = double.TryParse(input, out var value);
+      if (!valid) {
+        throw new ArgumentException("Invalid value (valid value format: \"" + FormatPatterns.GetDoubleFormatPattern() + "\")");
+      }
+
+      return value;
+    }
+
+    private static int ParseDerivationCount(string input) {
+      switch (input) {
+        case "":
+          return 1;
+        case "²":
+          return 2;
+        case "³":
+          return 3;
+        default:
+          int.TryParse(input, out var value);
+          return value;
+      }
+    }
+  }
+}
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 17901)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 17902)
@@ -35,5 +35,5 @@
     protected const string TargetVariableParameterName = "TargetVariable";
     protected const string VariableRangesParameterName = "VariableRanges";
-    protected const string IntervalConstraintsParameterName = "IntervalConstraints";
+    protected const string ShapeConstraintsParameterName = "ShapeConstraints";
     public string Filename { get; set; }
 
@@ -94,4 +94,5 @@
       problemData.Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>()));
       problemData.Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, "", new IntervalCollection()));
+      problemData.Parameters.Add(new FixedValueParameter<ShapeConstraints>(ShapeConstraintsParameterName, "", new ShapeConstraints()));
       emptyProblemData = problemData;
     }
@@ -107,4 +108,9 @@
       get => VariableRangesParameter.Value;
     }
+
+    public IFixedValueParameter<ShapeConstraints> ShapeConstraintsParameter =>
+      (IFixedValueParameter<ShapeConstraints>) Parameters[ShapeConstraintsParameterName];
+
+    public ShapeConstraints ShapeConstraints => ShapeConstraintsParameter.Value;
 
 
@@ -140,4 +146,13 @@
         Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, intervalCollection));
       }
+      if(Parameters.ContainsKey("IntervalConstraints")) {
+        var param = (IFixedValueParameter<ShapeConstraints>)Parameters["IntervalConstraints"];
+        Parameters.Remove(param);
+        Parameters.Add(new FixedValueParameter<ShapeConstraints>(ShapeConstraintsParameterName, param.Value));
+      }
+      if (!Parameters.ContainsKey(ShapeConstraintsParameterName)) {
+        Parameters.Add(new FixedValueParameter<ShapeConstraints>(ShapeConstraintsParameterName, new ShapeConstraints()));
+      }
+
       RegisterParameterEvents();
     }
@@ -163,10 +178,19 @@
     }
 
-    public RegressionProblemData(IDataset dataset, IEnumerable<string> allowedInputVariables, string targetVariable, IEnumerable<ITransformation> transformations = null)
+    public RegressionProblemData(IDataset dataset, IEnumerable<string> allowedInputVariables, string targetVariable, 
+      IEnumerable<ITransformation> transformations = null,
+      IntervalCollection variableRanges = null,
+      ShapeConstraints shapeConstraints = null)
       : base(dataset, allowedInputVariables, transformations ?? Enumerable.Empty<ITransformation>()) {
       var variables = InputVariables.Select(x => x.AsReadOnly()).ToList();
       Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>(variables), variables.Where(x => x.Value == targetVariable).First()));
-      var intervalCollection = CalculateDatasetIntervals(this.Dataset);
-      Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, intervalCollection));
+      if (variableRanges == null) {
+        variableRanges = CalculateDatasetIntervals(this.Dataset);
+      }
+      Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, variableRanges));
+      if (shapeConstraints == null) {
+        shapeConstraints = new ShapeConstraints();
+      } 
+      Parameters.Add(new FixedValueParameter<ShapeConstraints>(ShapeConstraintsParameterName, shapeConstraints));
       RegisterParameterEvents();
     }
@@ -174,5 +198,5 @@
     private static IntervalCollection CalculateDatasetIntervals(IDataset dataset) {
       IntervalCollection intervalCollection = new IntervalCollection();
-      foreach (var variable in dataset.DoubleVariables) {// intervals are only possible for double variables
+      foreach (var variable in dataset.DoubleVariables) { // intervals are only possible for double variables
         var variableInterval = Interval.GetInterval(dataset.GetDoubleValues(variable));
         intervalCollection.AddInterval(variable, variableInterval);
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ShapeConstraints.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ShapeConstraints.cs	(revision 17902)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ShapeConstraints.cs	(revision 17902)
@@ -0,0 +1,85 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+using System;
+using System.Linq;
+using System.Collections.Generic;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  [StorableType("A56BFB05-8F11-4766-9FBF-20C7010F1CA3")]
+  [Item("ShapeConstraints", "Represents shape constraints associated with a regression problem data e.g. monotonicity constraints.")]
+  public class ShapeConstraints : CheckedItemList<ShapeConstraint> {
+    public IEnumerable<ShapeConstraint> EnabledConstraints => base.CheckedItems.Select(checkedItem => checkedItem.Value);
+
+    protected override void OnItemsAdded(IEnumerable<IndexedItem<ShapeConstraint>> items) {
+      base.OnItemsAdded(items);
+      foreach (var item in items)
+        item.Value.Changed += Item_Changed;
+    }
+
+    protected override void OnItemsRemoved(IEnumerable<IndexedItem<ShapeConstraint>> items) {
+      base.OnItemsRemoved(items);
+      foreach (var item in items)
+        item.Value.Changed -= Item_Changed;
+    }
+
+    protected override void OnCollectionReset(
+      IEnumerable<IndexedItem<ShapeConstraint>> items,
+      IEnumerable<IndexedItem<ShapeConstraint>> oldItems) {
+      base.OnCollectionReset(items, oldItems);
+      foreach (var item in items)
+        item.Value.Changed += Item_Changed;
+      foreach (var item in oldItems)
+        item.Value.Changed -= Item_Changed;
+    }
+
+    private void Item_Changed(object sender, EventArgs e) {
+      RaiseChanged();
+    }
+
+    [StorableConstructor]
+    protected ShapeConstraints(StorableConstructorFlag _) : base(_) { }
+
+    protected ShapeConstraints(ShapeConstraints original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ShapeConstraints(this, cloner);
+    }
+
+    public ShapeConstraints() : base() {
+    }
+
+    public event EventHandler Changed;
+
+    private void RaiseChanged() {
+      var handlers = Changed;
+      if (handlers != null)
+        handlers(this, EventArgs.Empty);
+    }
+  }
+}
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs	(revision 17901)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs	(revision 17902)
@@ -1,3 +1,4 @@
 ﻿#region License Information
+
 /* HeuristicLab
  * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -18,4 +19,5 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
+
 #endregion
 
@@ -28,5 +30,6 @@
     string TargetVariable { get; set; }
 
-    IntervalCollection VariableRanges { get;}
+    IntervalCollection VariableRanges { get; }
+    ShapeConstraints ShapeConstraints { get; }
 
     IEnumerable<double> TargetVariableValues { get; }
